/*
 * AculCalParameters.h
 *
 *  Created on: Oct 20, 2016
 *      Author: vratik
 */

#ifndef ACULCALIB_ACULCALPARS_H_
#define ACULCALIB_ACULCALPARS_H_

#include <iostream>
#include <fstream>
#include <vector>

#include "TString.h"
#include "TArrayD.h"
#include "TArrayI.h"
#include "TCutG.h"

using std::cout;
using std::endl;
using std::vector;

class AculCalPars {

protected:
//general
	TString fParFileName;


	//todo energies used for calibration should be in this class

//CsI parameters
//	Int_t fNoCrystals;
//
//	TString fDetName;
//
//	Int_t fNoFiles;
//	vector<TString> fFileName;
//
//	Int_t fEnergyPoints;
//	TArrayD fE;
//

//Si parameteres
	//first
	//second
	//others

public:
	AculCalPars();
	AculCalPars(const char* parFile);
	virtual ~AculCalPars();
	ClassDef(AculCalPars,1);

	virtual void Init();

	//getters
	const char* GetParFileName() {return fParFileName.Data();}
//	Int_t GetNoCrystals() {return fNoCrystals;}
	virtual const char* GetDetName() {return 0;}
	virtual const char* GetParticleName() {return 0;}
	virtual Int_t GetNoRawFiles() {return 0;};
	virtual const char* GetFileName(Int_t i) {return 0;};
	virtual Int_t GetNoEPoints() {return 0;}
	virtual Double_t GetCalEnergy(Int_t i) {return 0.;};
	virtual const char* GetCutsFileName() {return 0;}
	virtual Int_t GetNoCuts() {return 0;}
	virtual TCutG* GetCut(Int_t i) {return 0;};
	virtual TCutG* GetCut(const char* cutName) {return 0;};
	virtual Int_t GetMinChannel(Int_t energy, Int_t crystal) {return 0;};
	virtual Int_t GetMaxChannel(Int_t energy, Int_t crystal) {return 0;};

	void SetParFileName(const char* parFile) {fParFileName = parFile;}

	void SetParFile(const char* parfile);
	virtual void PrintParameters(const char* option = "") {};

	virtual void Reset() {};

protected:
	virtual void SetPars() {};
};

#endif /* ACULCALIB_ACULCALPARS_H_ */
